# -*- coding: utf-8 -*-
# author:shihua
# coder:shihua
# 这是一个集成学习计算图控制元类，主要功能生成集成学习计算图控制类，主要技术__prepare__,__new__
"""
模块介绍
-------

这是一个集成学习计算图控制元类，主要功能生成集成学习计算图控制类，主要技术__prepare__,__new__

设计模式：

    （1）  无 

关键点：    

    （1）__prepare__
    
    （2）__new__

主要功能：            

    （1）管理集成学习控制类的创建

使用示例
-------


类说明
------

"""



####### 载入程序包 ##############################################################################
################################################################################################



from collections import OrderedDict
from cuber.manager.graph import *



####### 集成学习计算图控制元类 ###################################################################
### 功能：                                                                                    ###
### (1) 管理集成学习控制类的创建                                                               ###
### 技术：                                                                                    ###
### (1) __prepare__                                                                          ###
### (2) __new__                                                                              ###
################################################################################################



####### 集成学习计算图控制元类 ##################################################################
###############################################################################################



class ControllerMeta(type):
    '''
    类介绍：

        这是一个集成学习计算图控制元类，主要功能管理集成学习计算图控制类的生成，主要技术__prepare__,__new__
    '''


    @classmethod
    def __prepare__(cls,name,bases):
        '''
        方法功能：

            重载一个类创建准备方法，实现有序属性方法

        参数：
            name (str): 类名称
            bases (tuple): 基类元组

        返回：
            OrderedDict (dict): 类内定义的命名空间变量，使用有序字典规范类属性的顺序
        '''

        return OrderedDict()


    def __new__(cls,name,bases,attrs_dict,*args,**kwargs):
        '''
        方法功能：

            重载一个类创建方法，实现基于Networkx的DAG管理对象

        参数：
            name (str): 类名称
            bases (tuple): 基类元组
            attrs_dict (dict): 类内定义的命名空间变量，从__prepare__方法的返回接入

        返回：
            instance (object): 创建的类的实例(实际是一个对象)
        '''

        attrs_dict['manager'] = DirectedAcyclicGraph('DirectedAcyclicGraph')
        cls.instance = type.__new__(cls,name,bases,attrs_dict,*args,**kwargs)

        return cls.instance



#####################################################################################################
#####################################################################################################


        